diff -ur bitlbee-1.0.3/bitlbee.h bitlbee-passwdpatched-1.0.3/bitlbee.h
--- bitlbee-1.0.3/bitlbee.h	2006-06-24 16:00:43.000000000 +0200
+++ bitlbee-passwdpatched-1.0.3/bitlbee.h	2006-09-27 21:42:21.000000000 +0200
@@ -92,6 +92,7 @@
 #define IRCD_INFO "BitlBee <http://www.bitlbee.org/>"
 
 #define MAX_NICK_LENGTH 24
+#define MAX_PASSWORD_LENGTH 64
 
 #define HELP_FILE VARDIR "help.txt"
 #define CONF_FILE_DEF ETCDIR "bitlbee.conf"
diff -ur bitlbee-1.0.3/commands.c bitlbee-passwdpatched-1.0.3/commands.c
--- bitlbee-1.0.3/commands.c	2006-06-24 16:00:43.000000000 +0200
+++ bitlbee-passwdpatched-1.0.3/commands.c	2006-09-27 21:42:40.000000000 +0200
@@ -206,6 +206,12 @@
 			irc_usermsg( irc, "Not enough parameters" );
 			return( 0 );
 		}
+
+		if( prot == PROTO_OSCAR && strlen(cmd[5])>=MAX_PASSWORD_LENGTH )
+		{
+			irc_usermsg( irc, "Password to long" );
+			return( 0 );
+		}
 		
 		a = account_add( irc, prot, cmd[3], cmd[4] );
 		
diff -ur bitlbee-1.0.3/protocols/nogaim.h bitlbee-passwdpatched-1.0.3/protocols/nogaim.h
--- bitlbee-1.0.3/protocols/nogaim.h	2006-06-24 16:00:44.000000000 +0200
+++ bitlbee-passwdpatched-1.0.3/protocols/nogaim.h	2006-09-27 21:43:19.000000000 +0200
@@ -1,4 +1,4 @@
-  /********************************************************************\
+  / ********************************************************************\
   * BitlBee -- An IRC to other IM-networks gateway                     *
   *                                                                    *
   * Copyright 2002-2004 Wilmer van der Gaast and others                *
@@ -84,7 +84,7 @@
 	
 	char username[64];
 	char displayname[128];
-	char password[32];
+	char password[MAX_PASSWORD_LENGTH];
 	guint keepalive;
 	/* stuff needed for per-connection idle times */
 	guint idle_timer;
@@ -138,7 +138,7 @@
 struct aim_user {
 	char username[64];
 	char alias[SELF_ALIAS_LEN]; 
-	char password[32];
+	char password[MAX_PASSWORD_LENGTH];
 	char user_info[2048];
 	int options;
 	int protocol;
